SystemOrganization addCategory: #GTD!
SystemOrganization addCategory: 'GTD-Commands'!
SystemOrganization addCategory: 'GTD-Model'!
SystemOrganization addCategory: 'GTD-Tests'!

Object subclass: #Agente
	instanceVariableNames: 'proyectos realizacionesDeProyectos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Model'!

!Agente commentStamp: 'SergioFedi 4/24/2015 18:49' prior: 0!
Soy una entidad que tiene agencia. Es decir, que quiere lograr algo en la realidad. Por lo tanto voya tener proyectos que voy a querer llevar a cabo.!

!Agente methodsFor: 'public' stamp: 'FedericoFigueredo 4/23/2015 11:00'!
addProyecto: aProyecto 
	self proyectos add: aProyecto.! !

!Agente methodsFor: 'initialization' stamp: 'FedericoFigueredo 4/23/2015 11:07'!
initialize

	self proyectos: OrderedCollection new.! !

!Agente methodsFor: 'public' stamp: 'FedericoFigueredo 4/23/2015 14:45'!
nextActions
	^ self realizacionesDeProyectos collect: [ :aRealizacionDeProyecto | aRealizacionDeProyecto nextAction ].
	! !

!Agente methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/23/2015 11:02'!
proyectos
	^ proyectos! !

!Agente methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/23/2015 11:02'!
proyectos: anObject
	proyectos := anObject! !

!Agente methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/23/2015 14:47'!
realizacionesDeProyectos
	^ realizacionesDeProyectos! !

!Agente methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/23/2015 14:47'!
realizacionesDeProyectos: anObject
	realizacionesDeProyectos := anObject! !

Object subclass: #AgregarProyectoCmd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Commands'!

!AgregarProyectoCmd commentStamp: 'SergioFedi 4/25/2015 10:07' prior: 0!
Modelo el agregado de un Proyecto al sistema desde fuera del sistema.
!

Object subclass: #Proyecto
	instanceVariableNames: 'nombre condicionDeExito acciones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Model'!

!Proyecto commentStamp: 'FedericoFigueredo 4/23/2015 14:28' prior: 0!
Llamamos Proyecto a un estado de la realidad deseado para el cual se requieren la realización de más de una acción.!

!Proyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/22/2015 13:12'!
acciones
	^ acciones! !

!Proyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/22/2015 13:12'!
acciones: anObject
	acciones := anObject! !

!Proyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/22/2015 13:12'!
condicionDeExito
	^ condicionDeExito! !

!Proyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/22/2015 13:12'!
condicionDeExito: anObject
	condicionDeExito := anObject! !

!Proyecto methodsFor: 'public' stamp: 'FedericoFigueredo 4/22/2015 13:12'!
nombre
	^ nombre! !

!Proyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/22/2015 13:12'!
nombre: anObject
	nombre := anObject! !

Object subclass: #RealizacionDeUnProyecto
	instanceVariableNames: 'proyecto agente nextAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Model'!

!RealizacionDeUnProyecto commentStamp: 'FedericoFigueredo 4/23/2015 15:25' prior: 0!
Llamamos realizacionDeUnProyecto a la entidad que tiene la información sobre el devenir real de un proyecto. Es decir, la información sobre un proyecto desde que nace hasta que muere.

Ejemplo:
Que un proyecto esté comenzado, a mediados o finalizado lo va a representar esta entidad.!

!RealizacionDeUnProyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/23/2015 14:34'!
agente
	^ agente! !

!RealizacionDeUnProyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/23/2015 14:34'!
agente: anObject
	agente := anObject! !

!RealizacionDeUnProyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/23/2015 14:35'!
nextAction
	^ nextAction! !

!RealizacionDeUnProyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/23/2015 14:35'!
nextAction: anObject
	nextAction := anObject! !

!RealizacionDeUnProyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/23/2015 14:35'!
proyecto
	^ proyecto! !

!RealizacionDeUnProyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/23/2015 14:35'!
proyecto: anObject
	proyecto := anObject! !

TestCase subclass: #AgenteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Tests'!

!AgenteTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/23/2015 15:14'!
newAgenteDePrueba
	| agente unProyecto acciones |
	
	agente := Agente new.
	unProyecto := Proyecto new.
	acciones := OrderedCollection new.
	acciones
		add: 'Llamar al dentista para pedir un turno';
		add: 'Agregar el turno a mi calendario';
		add: 'Ir a la consulta';
		add: 'Cargar la tarjeta SUBE'.
	"Lo siguiente resuelve como shorthand lo que está abajo 
	 unProyecto nombre: 'Chequeo Dental'.
	 unProyecto condicionDeExito: 'Saber el estado actual de mis dientes'.
	 unProyecto acciones: acciones."
	unProyecto
		nombre: 'Chequeo Dental';
		condicionDeExito: 'Saber el estado actual de mis dientes';
		acciones: acciones.
	agente addProyecto: unProyecto.
	
	^ agente.! !

!AgenteTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/23/2015 15:33'!
test_01_AltaDeUnProyecto
	| agente  |
	
	agente := self newAgenteDePrueba.
	self assert: agente proyectos notEmpty.
	self assert: agente realizacionesDeProyectos notEmpty.! !

!AgenteTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/23/2015 13:56'!
test_02_CualesSonLasNextActions
	| agente actions expectedAction |

	agente := self newAgenteDePrueba.
	actions := agente nextActions.
	expectedAction := 'Llamar al dentista para pedir un turno'.
	
	self assert: actions anyOne = expectedAction.! !

!AgenteTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/23/2015 14:07'!
test_03_MarcarUnaNextActionComoHecha

	| agente accionAMarcar descripcionDeLaAccionAMarcar accionSiguiente |
	
	agente := self newAgenteDePrueba.
	descripcionDeLaAccionAMarcar :=  'Llamar al dentista para pedir un turno'.
	accionSiguiente := 'Agregar el turno a mi calendario'.
	accionAMarcar := agente nextActions anyOne.
	
	self assert: accionAMarcar = descripcionDeLaAccionAMarcar.
	agente marcarComoHecha: accionAMarcar.
	self assert: agente nextActions anyOne = accionSiguiente.! !

!AgenteTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/23/2015 15:32'!
test_04_MarcarUnaNoNextActionComoHecha

	| agente accionAMarcar descripcionDeLaAccionAMarcar accionSiguiente realizacion |
	
	agente := self newAgenteDePrueba.
	descripcionDeLaAccionAMarcar :=  'Cargar la tarjeta SUBE'.
	accionSiguiente := 'Llamar al dentista para pedir un turno'.
	realizacion := agente realizacionesDeProyectos first.
	accionAMarcar := realizacion proyecto acciones last.
	
	self assert: accionAMarcar = descripcionDeLaAccionAMarcar.
	self deny: (realizacion isHecha: accionAMarcar).
	agente marcarComoHecha: accionAMarcar.
	self assert: agente nextActions anyOne = accionSiguiente.
	self assert: (realizacion isHecha: accionAMarcar).
	! !

TestCase subclass: #RealizacionDeUnProyectoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Tests'!

!RealizacionDeUnProyectoTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 4/25/2015 10:11'!
test_01_SaberSiUnaAccionEstaHecha

	self assert: false.! !

!RealizacionDeUnProyectoTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 4/25/2015 10:11'!
test_02_MarcarUnaAccionComoHecha

	self assert: false.! !
